/*
 * This file is part of LibertyTunnel.
 *
 * LibertyTunnel is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * LibertyTunnel is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with LibertyTunnel.  If not, see <https://www.gnu.org/licenses/>.
 */

package io.github.krlvm.powertunnel.plugins.libertytunnel;

import io.github.krlvm.powertunnel.sdk.plugin.PluginInfo;
import io.github.krlvm.powertunnel.sdk.proxy.ProxyAddress;

public class PACGenerator {

    static String generatePAC(ProxyAddress address, PluginInfo info, String[] hosts) {
        final StringBuilder script = new StringBuilder("/**\nThis file is generated by " + info.getName() + "\n" + info.getHomepage() + "\n**/\n");
        script.append("function FindProxyForURL(url, host) { if(");
        int i = 0;
        for (String host : hosts) {
            if(host.startsWith("*")) {
                // We assume it looks like "*.google.com"
                host = host.replaceFirst("\\*.", "");
            }
            script.append("(dnsDomainIs(host, \"").append(host).append("\"))");
            if(++i != hosts.length) script.append(" || ");
        }
        script.append(") { return 'PROXY ").append(address.toString()).append("'; } else { return 'DIRECT'; } }");

        return script.toString();
    }
}